/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   SatelliteLoop.cpp
 * Author: Maxi
 * 
 * Created on 6. Dezember 2018, 14:28
 */

#include "SatelliteLoop.h"

SatelliteLoop::SatelliteLoop() {
}

SatelliteLoop::SatelliteLoop(const SatelliteLoop& orig) {
}

SatelliteLoop::~SatelliteLoop() {
}

void SatelliteLoop::writeInCsv(std::ofstream &streamData)
{
    //helping variables
    int i=0;
    int j=0;
    int k=0;
    int iSizeVec=0;
    int iArrayEgnosPRN[3]={1,4,17};
    int iArrayMaxSatellites[4]={MaxSatellitesGPS, MaxSatellitesEGNOS, MaxSatellitesGLONASS, MaxSatellitesGALILEO};
    int iArrayAmountSat[4]={iAmountGPS,iAmountEGNOS,iAmountGLO,iAmountGAL};
    
    //write down amount in order to compare because normally always identical
    iSizeVec=getTotalVectorSize();
        
    //if number of satellites greater than one
    //then extract information from satellite vector
    if( iAmountSat>0 && (iAmountSat==iSizeVec))
    {
        
        //write Satellite attributes in File   
        /*
        for(i=0;i<iNumPotentialSat;i++)
        {
            if(i>=iAmountGPS && i<=MaxSatellitesGPS)
            {
                pSatellite->resetSatellite();
                pSatellite->writeInFile(streamData);
            }
            else if (i>=(iAmountEGNOS+iAmountGPS) &&
                    i<=(MaxSatellitesEGNOS+MaxSatellitesGPS))
            {
                pSatellite->resetSatellite();
                pSatellite->writeInFile(streamData);
            }
            else if (i>=(iAmountGLO+iAmountEGNOS+iAmountGPS) &&
                    i<=(MaxSatellitesGLONASS+MaxSatellitesEGNOS+MaxSatellitesGPS))
            {
                pSatellite->resetSatellite();
                pSatellite->writeInFile(streamData);
            }
            else if (i>=(iAmountGAL+iAmountGLO+iAmountEGNOS+iAmountGPS) &&
                    i<=(MaxSatellitesGALILEO+MaxSatellitesGLONASS+MaxSatellitesEGNOS+MaxSatellitesGPS))
            {
                pSatellite->resetSatellite();
                pSatellite->writeInFile(streamData);
            }
            else if (i>=(iAmountBEI+iAmountGLO+iAmountEGNOS+iAmountGPS) &&
                    i<=(MaxSatellitesBEIDOU+MaxSatellitesGLONASS+MaxSatellitesEGNOS+MaxSatellitesGPS))
            {
                pSatellite->resetSatellite();
                pSatellite->writeInFile(streamData);
            }
            else
            {
                this->vecSatellite[i].writeInFile(streamData);
            }
        }
        */

        //*******************************************************

        if(arraybSatSys[3]==0)//if user choseBaisou instead of Galileo
        {
            iArrayMaxSatellites[3] = MaxSatellitesBEIDOU;
            iArrayAmountSat[3]= iAmountBEI;
        }

        //reset helping variables
        
        
        for(j=0;j<4;j++)
        {
            k=0;//reset k for every new satellite system
            
            for(i=0; i<iArrayMaxSatellites[j]; i++)
            {
                if((arraybSatSys[j]==1||(arraybSatSys[j]==0 && j==3)))
                {
                    if( ( (int)vecSatellite[j][k].getSvId() )==(i+1) &&
                            (j!=1)  &&
                            iArrayAmountSat[j]>0 
                      )//check if this satellite system was chosen to be decoded
                    {
                        vecSatellite[j][k].writeInFile(streamData);
                        k++;
                        //std::cout<<"k-regular:"<<k<<std::endl;
                    }
                    //EGNOS => PRN={1,4,17}
                    else if( (j==1) && 
                            ( iArrayEgnosPRN[i]==( (int)vecSatellite[j][k].getSvId() ) )  &&
                            iArrayAmountSat[j]>0  
                           )
                    {
                         vecSatellite[j][k].writeInFile(streamData);
                         k++;
                         //std::cout<<"k-Egnos:"<<k<<std::endl;
                    }
                    else
                    {
                        streamData<<NAN<<";";
                        streamData<<NAN<<";";
                        streamData<<NAN<<";";
                        streamData<<NAN<<";";
                    }
                }
                
            }
        }
        
        /*
        for(j=0;j<4;j++)
        {

            if(arraybSatSys[j]==1||(arraybSatSys[j]==0 && j==3))//check if satellite system should be decoded 
            {
                //Loop through columns with the maximum of satellites 
                //in order to fill even the empty coloumns
                for(i=0; i<iArrayMaxSatellites[j]; i++)
                {
                    //check if vector does not contain anymore satellites
                    //of the j-th Satellite system 
                    //std::cout<<"Amount:"<<j<<" Sat:"<<iArrayAmountSat[j]<<std::endl;

                    if(i>=iArrayAmountSat[j])
                    {
                        streamData<<NAN<<";";
                        streamData<<NAN<<";";
                        streamData<<NAN<<";";
                        streamData<<NAN<<";";
                    }
                     // write down correct vector content of one satellite
                    else if( i<iArrayAmountSat[j] && 
                            (static_cast<int>(currentSatSys)==(int)vecSatellite[i+iMemory].getgnssId()) )
                    {
                        //std::cout<<"write Satellite"<<std::endl;
                        vecSatellite[i+iMemory].writeInFile(streamData);
                    }
                    else//cases where i<iArrayAmountSat[j] however vecSatellite[i+iMemory].getgnssId()+=1 
                    {
                        std::cout<<"WTF!!!!!!!!!!!!!!!!!!!!!!!!!!"<<std::endl;
                    }
                    //last ith element of a certain satellite group triggers
                    //the preservation of the pointer position
                    if(  i==(iArrayMaxSatellites[j]-1) && iArrayAmountSat[j]>0 )
                    {
                        iMemory+=iArrayAmountSat[j];
                        //std::cout<<"Memory:"<<iMemory<<std::endl;
                        ++currentSatSys;
                    }
                    //increases memory for 
                    //last ith element of a satellite system which does not appear in that epoch
                    else if(i==(iArrayMaxSatellites[j]-1) && iArrayAmountSat[j]==0)
                    {
                        //iMemory+=1;
                        ++currentSatSys;
                        //std::cout<<"Memory:"<<iMemory<<std::endl;
                    }
                }
            }
            else if(arraybSatSys[j]==0 && j<3)
            {
                 iMemory+=iArrayAmountSat[j];
            }
        }
        */
        
        /*
        if(arraybSatSys[0]==1)//Does the user want to decode GPS?
        {
            for(i=0;i<MaxSatellitesGPS;i++)
            {
                if(i>=iAmountGPS && i<=MaxSatellitesGPS)
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else
                {
                    this->vecSatellite[i].writeInFile(streamData);
                }
            }
        }
        //*******************************************************
        if(arraybSatSys[1]==1)//Does the user want to decode EGNOS?
        {
            for(i=0;i<MaxSatellitesEGNOS;i++)
            {
                if(i>=iAmountEGNOS && i<=MaxSatellitesEGNOS)
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else
                {
                    this->vecSatellite[i].writeInFile(streamData);
                }
            }
        }
        //*******************************************************
        if(arraybSatSys[2]==1)//Does the user want to decode GLONASS?
        {
            for(i=0;i<MaxSatellitesGLONASS;i++)
            {
                if(i>=iAmountEGNOS && i<=MaxSatellitesGLONASS)
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else
                {
                    this->vecSatellite[i].writeInFile(streamData);
                }
            }
        }
        else if()
        if(arraybSatSys[3]==1)//Does the user want to decode EGNOS?
        {
            for(i=0;i<MaxSatellitesGALILEO;i++)
            {
                if(i>=iAmountEGNOS && i<=MaxSatellitesGALILEO)
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else
                {
                    this->vecSatellite[i].writeInFile(streamData);
                }
            }
        }
        if(arraybSatSys[3]==0)//Does the user want to decode EGNOS?
        {
            for(i=0;i<MaxSatellitesBEIDOU;i++)
            {
                if(i>=iAmountEGNOS && i<=MaxSatellitesBEIDOU)
                {
                    pSatellite->resetSatellite();
                    pSatellite->writeInFile(streamData);
                }
                else
                {
                    this->vecSatellite[i].writeInFile(streamData);
                }
            }
        }

        */
    }
    else if(iAmountSat > 0 && (iAmountSat != iSizeVec) )
    {
        std::cout<<"something wrong!!!!!!!!!!!!!!!!!!!!!:   "<<iSizeVec<<std::endl;
        std::cout<<"Amount Sat:     "<<iAmountSat<<std::endl;
        int iWhat=0;
        std::cout<<"This Message should not appear"<<std::endl;
        std::cout<<"Please write a number to continue"<<std::endl;
        std::cin>>iWhat;
    }
    else if(iAmountSat==0)
    {
        //std::cout<<"Fill loop__Vecotr:"<<iSizeVec<<"Potential SAT"<<iNumPotentialSat<<std::endl;
        for(i=0;i<iNumPotentialSat;i++)
        {
            streamData<<NAN<<";";
            streamData<<NAN<<";";
            streamData<<NAN<<";";
            streamData<<NAN<<";";
        }
    }

}

void SatelliteLoop::readOfFile(char*** pcInputData)
{
    //Helping Variables
    int i=0;
    //int j=0;
    //int ilastSatSys=0;
    int icurrentSatSys=0;
    //int inextSatSys=0;
    
    //int iArrayMaxSatellites[4]={MaxSatellitesGPS, MaxSatellitesEGNOS, MaxSatellitesGLONASS, MaxSatellitesGALILEO};
    //int iArrayAmountSat[4]={iAmountGPS,iAmountEGNOS,iAmountGLO,iAmountGAL};
    
    //int iMemory=0;
    
    //space for the satellite vector needs to be reserved
    
    
    try
    {
        for(i=0;i<4;i++)
        {
            this->vecSatellite[i].reserve(15*sizeof(SATELLITE));
        }
    }
    catch(const std::bad_alloc& e)
    {
        std::cout << "Allocation failed in SatelliteLoop in readOfFile: " << e.what() << '\n';
    }
    
    
    //reset Attributes
    iAmountGPS=0;
    iAmountEGNOS=0;
    iAmountGLO=0;
    iAmountGAL=0;
    iAmountBEI=0;
    
    //Read all sytellite related information and save the amount of each satellite system.
    for(i=0;i<iAmountSat;i++)
    {
        //Read Data in object pointer
        this->pSatellite->readOfFile(&pcInputData);
        
        //this->pSatellite->viewData();
        //ilastSatSys=((int)vecSatellite.back().getgnssId());
        //icurrentSatSys=static_cast<int>(currentSatSys);
        
        icurrentSatSys=((int)pSatellite->getgnssId());
        assignSatSys(currentSatSys, icurrentSatSys);
        assignAmountGNSS(currentSatSys);
        
        /*
        //enter the correct satellite into the corresponding column
        if(i==0)//start
        {
            //static_cast<int>(currentSatSys)=((int)pSatellite->getgnssId());
            assignSatSys(currentSatSys, inextSatSys);
            //std::cout<<"Test_first: current status: "<<static_cast<int>(currentSatSys)<<std::endl;
            completeAmountListBeginning(currentSatSys);
        }
        else if( 0<i && i<(iAmountSat-1) &&
                ilastSatSys == icurrentSatSys && inextSatSys != icurrentSatSys )//middle
        {
            //save amounts of every satellite system
            assignAmountGNSS(currentSatSys, i);

            assignSatSys(currentSatSys, inextSatSys);
        }
        else if(i==(iAmountSat-1))//last satellite
        {
            assignSatSys(thisSatSys, inextSatSys);
            if(currentSatSys==thisSatSys)
            {
                assignAmountGNSS(currentSatSys, i);
                completeAmountListEnding(currentSatSys);
            }
            else if(currentSatSys!=thisSatSys)
            {
                assignAmountGNSS(currentSatSys, i);
                assignAmountGNSS(thisSatSys, (i+1) );
                completeAmountListEnding(thisSatSys);
            }
        }
        else
        {
            assignSatSys(currentSatSys, (int)pSatellite->getgnssId());
            std::cout<<"Test_third: current status: "<<static_cast<int>(currentSatSys)<<std::endl;
        }
        */

        /*
        std::cout<<"GNSS ID:"<<std::endl;
        std::cin>>uint8dummy;
        this->pSatellite->gnssId=(unsigned char)uint8dummy;

        std::cout<<"Space Vehicle ID:"<<std::endl;
        std::cin>>uint8dummy;
        this->pSatellite->svId=(unsigned char)uint8dummy;

        std::cout<<"Elevation:"<<std::endl;
        std::cin>>this->pSatellite->elev;

        std::cout<<"Azimuth:"<<std::endl;
        std::cin>>this->pSatellite->azim;

        std::cout<<"GNSS ID:"<<(int)this->pSatellite->gnssId<<std::endl;
        std::cout<<"Space Vehicle ID:"<<(int)this->pSatellite->svId<<std::endl;
        std::cout<<"Elevation:"<<this->pSatellite->elev<<std::endl;
        std::cout<<"Azimuth:"<<this->pSatellite->azim<<std::endl;
        */

        //include new satellite object in satellite vector
        fillVector(currentSatSys);
        //Reset Satellite pointer, placeholder
        pSatellite->resetSatellite();
    }
}
/*
void SatelliteLoop::completeAmountListBeginning(enumSatelliteSystems &SatSys)
{
    //if(static_cast<int>(SatSys)==1)
    
    switch(SatSys)
    {
        case enumSatelliteSystems::Gps:
        {
            break;
        }
        case enumSatelliteSystems::Egnos:
        { 
            iAmountGPS=0;
            break;
        }
        case enumSatelliteSystems::Glonass:
        {
            iAmountGPS=0;
            iAmountEGNOS=0;
            break;
        }
        case enumSatelliteSystems::Galileo:
        {
            iAmountGPS=0;
            iAmountEGNOS=0;
            iAmountGLO=0;
            break;
        }
        case enumSatelliteSystems::Beidou:
        {
            iAmountGPS=0;
            iAmountEGNOS=0;
            iAmountGLO=0;
            iAmountGAL=0;
            break;
        }
        default:
        {
            std::cout<<"Satellite no recognized!!! The satellite system exceeds the known knowledge!"<<std::endl;
            break;
        }
    }
}
void SatelliteLoop::completeAmountListEnding(enumSatelliteSystems &SatSys)
{
    switch(SatSys)
    {
        case enumSatelliteSystems::Gps:
        {
            iAmountEGNOS=0;
            iAmountGLO=0;
            iAmountGAL=0;
            iAmountBEI=0;
            break;
        }
        case enumSatelliteSystems::Egnos:
        { 
            iAmountGLO=0;
            iAmountGAL=0;
            iAmountBEI=0;
            break;
        }
        case enumSatelliteSystems::Glonass:
        {
            iAmountGAL=0;
            iAmountBEI=0;
            break;
        }
        case enumSatelliteSystems::Galileo:
        {
            iAmountBEI=0;
            break;
        }
        case enumSatelliteSystems::Beidou:
        {
            iAmountGAL=0;
            break;
        }
        default:
        {
            std::cout<<"Satellite no recognized!!! The satellite system exceeds the known knowledge!"<<std::endl;
            break;
        }
    }
}
*/
void SatelliteLoop::assignSatSys(enumSatelliteSystems &SatSys,int iconstexpres)
{
    switch(iconstexpres)
    {
        case 1:
        {
            SatSys=enumSatelliteSystems::Gps;
            break;
        }
        case 2:
        { 
            SatSys=enumSatelliteSystems::Egnos;
            break;
        }
        case 4:
        {
            SatSys=enumSatelliteSystems::Glonass;
            break;
        }
        case 8:
        {
            SatSys=enumSatelliteSystems::Galileo;
            break;
        }
        case 32:
        {
            SatSys=enumSatelliteSystems::Beidou;
            break;
        }
        default:
        {
            std::cout<<"No Satellite assignable"<<std::endl;
            break;
        }
    }
}
void SatelliteLoop::assignAmountGNSS(enumSatelliteSystems &SatSys)
{
    if(SatSys==enumSatelliteSystems::Gps)
    {
        iAmountGPS++;
        //std::cout<<"GPS:        "<<iAmountGPS<<std::endl;
    }
    else if(SatSys==enumSatelliteSystems::Egnos)
    {
        iAmountEGNOS++;
        //std::cout<<"EGNOS:      "<<iAmountEGNOS<<std::endl;
    }
    else if(SatSys==enumSatelliteSystems::Glonass)
    {
        iAmountGLO++;
        //std::cout<<"GLONASS:    "<<iAmountGLO<<std::endl;
    }
    else if(SatSys==enumSatelliteSystems::Galileo)
    {
        iAmountGAL++;
        //std::cout<<"GALILEO:    "<<iAmountGAL<<std::endl;
    }
    else if(SatSys==enumSatelliteSystems::Beidou)
    {
        iAmountBEI++;
    }
    else
    {
        std::cout<<"Not recognizable satellite!!!!!!!!!!!!!"<<std::endl;
    }
}
void SatelliteLoop::fillVector(enumSatelliteSystems &SatSys)
{
    //int i=static_cast<int>(currentSatSys);
    try
    {
        switch(SatSys)
        {
            case enumSatelliteSystems::Gps:
            {
                vecSatellite[0].push_back(*pSatellite);
                break;
            }
            case enumSatelliteSystems::Egnos:
            { 
                vecSatellite[1].push_back(*pSatellite);
                break;
            }
            case enumSatelliteSystems::Glonass:
            {
                vecSatellite[2].push_back(*pSatellite);
                break;
            }
            case enumSatelliteSystems::Galileo:
            {
                vecSatellite[3].push_back(*pSatellite);
                break;
            }
            case enumSatelliteSystems::Beidou:
            {
                vecSatellite[3].push_back(*pSatellite);
                break;
            }
            default:
            {
                std::cout<<"Satellite no recognized!!! The satellite system exceeds the known knowledge!"<<std::endl;
                break;
            }
        }
    }
    catch(const std::bad_alloc& e)
    {
        std::cout << "Allocation failed in SatelliteLoop in fillvector: " << e.what() << '\n';
    }
    
}
void SatelliteLoop::setiNumPotentialSat(int iAmount)
{
    iNumPotentialSat=iAmount;
}
void SatelliteLoop::setArraybSatSys(bool pbArray[])
{
    int i=0;
    for(i=0;i<4;i++)
    {
        arraybSatSys[i]=pbArray[i];
    }
}
int SatelliteLoop::getTotalVectorSize()
{
    int i=0;
    int j=0;
    
    for(i=0;i<4;i++)
    {
        
        j+=this->vecSatellite[i].size();
        
    }
    //std::cout<<"vec Size:   "<<j<<std::endl;
    return j;
}
void SatelliteLoop::clearAllVectors()
{
    int i=0;
    for(i=0;i<4;i++)
    {
        this->vecSatellite[i].clear();
    }
}
void SatelliteLoop::setiAmountSat(int iAmount)
{
    iAmountSat=iAmount;
}
void SatelliteLoop::resetPointers()
{
    delete pSatellite;
}