/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   SATELLITE.cpp
 * Author: Maxi
 * 
 * Created on 14. November 2018, 18:16
 */



#include "SATELLITE.h"

SATELLITE::SATELLITE() {
}

SATELLITE::SATELLITE(const SATELLITE& orig) 
{
    this->gnssId=orig.gnssId;
    this->svId=orig.svId;
    this->azim=orig.azim;
    this->elev=orig.elev;
}

SATELLITE::~SATELLITE() {
}

void SATELLITE::writeInFile(std::ofstream &refOutputData)
{
    //Write GNSSID
    refOutputData<<(int)this->gnssId<<";";
    //std::cout<<"GNSSID Out:"<<(int)this->gnssId<<std::endl;
    //write Satellite identifier
    refOutputData<<(int)this->svId<<";";
    //write Elevation of Satellite
    refOutputData.setf(std::ios_base::fixed, std::ios_base::floatfield);//specify the precision
    refOutputData<<std::setprecision(10)<<this->elev<<";";
    //write Azimuth of Satellite
    refOutputData<<std::setprecision(10)<<this->azim<<";";
    refOutputData.unsetf(std::ios_base::floatfield);//normalize the precision
}

void SATELLITE::readOfFile(char**** pcInputData)
{
    this->gnssId=CpyUnsignChar(**pcInputData);
    
    this->svId=CpyUnsignChar(**pcInputData);
    
    this->elev=CpyDouble(**pcInputData);
    
    this->azim=CpyDouble(**pcInputData);
    
    /*
    std::cout<<"GNSSID In:"<<(int)this->gnssId<<std::endl;
    std::cout<<"SVID In:"<<(int)this->svId<<std::endl;
    std::cout<<"Elev In:"<<this->elev<<std::endl;
    std::cout<<"Azim In:"<<this->azim<<std::endl;
    */
}
void SATELLITE::resetSatellite()
{
    this->gnssId=0;
    
    this->svId=0;
    
    this->elev=NAN;
    
    this->azim=NAN;
}
void SATELLITE::viewData()
{
    std::cout<<"GNSSID:"<<(int)this->gnssId<<std::endl;
    std::cout<<"SVID:"<<(int)this->svId<<std::endl;
    std::cout<<"Elev:"<<this->elev<<std::endl;
    std::cout<<"Azim:"<<this->azim<<std::endl;
}
unsigned char SATELLITE::getgnssId()
{
    return gnssId;
}
unsigned char SATELLITE::getSvId()
{
    return svId;
}